#include <sourcemod>
#include <sdktools_sound>
#include <morecolors>



public Plugin myinfo =
{
	name = "admin_warning",
	author = "91346706501435897134",
	description = "Allows admins to send direct warnings to a specified user.",
	version = "1.7",
};



ConVar sm_send_warning_play_sound = null;



public void OnPluginStart()
{
	LoadTranslations("common.phrases");
	
	sm_send_warning_play_sound = CreateConVar("sm_send_warning_play_sound", "1", "play sound when message is send to the client?");
	
	RegAdminCmd("sm_send_warning", send_warning, ADMFLAG_CHAT, "Sends warning to a specified client");
	RegAdminCmd("sm_send_warn", send_warning, ADMFLAG_CHAT, "Sends warning to a specified client");
	RegAdminCmd("sm_warn", send_warning, ADMFLAG_CHAT, "Sends warning to a specified client");

	AutoExecConfig(true);
	
	OnMapStart();
}



public void OnMapStart()
{
	PrecacheSound("weapons/sniper_shoot_large.wav", true);
}



public Action send_warning(int client, int args)
{
	bool play_sound = GetConVarBool(sm_send_warning_play_sound);
	
	char target[MAX_NAME_LENGTH];
	char message[102];
	char buffer[102];
	
	if (args < 2)
	{
		ReplyToCommand(client, ">> usage: sm_send_warning <name|#userid> <message>");
		
		return Plugin_Handled;
	}
	
	GetCmdArg(1, target, sizeof(target));
	char target_name[MAX_TARGET_LENGTH];
	int target_list[MAXPLAYERS];
	int target_count;
	bool tn_is_ml;
	if ((target_count = ProcessTargetString(
			target,
			client,
			target_list,
			MAXPLAYERS,
			COMMAND_FILTER_NO_BOTS,
			target_name,
			sizeof(target_name),
			tn_is_ml
			)) <= 0)
			{
				ReplyToCommand(client, ">> no matching client was found.");
			
				return Plugin_Handled;
			}
	
	if (args > 1)
	{
		GetCmdArg(2, message, sizeof(message));
		for (int i = 3; i <= args; i++)
		{
			GetCmdArg(i, buffer, sizeof(buffer));
			Format(message, sizeof(message), "%s %s", message, buffer);
		}
		if (strlen(message) > 100)
		{
			ReplyToCommand(client, ">> message cannot exceed 100 characters");
			return Plugin_Handled;
		}
	}
	
	for (int i = 0; i < target_count; i++)
	{
		CPrintToChat(target_list[i], "{FULLRED}>> Warning from admin: {ORANGE}%s", message);
		
		if (play_sound)
		{
			EmitSoundToClient(target_list[i], "weapons/sniper_shoot_large.wav");
		}
		
		LogAction(client, target_list[i], ">> \"%L\" Warned \"%L\" | message: \"%s\"", client, target_list[i], message);
	}
	if (tn_is_ml)
	{
		if (client != 0)
		{
			CPrintToChat(client, "{FULLRED}>> You warned {ORANGE}%s{FULLRED} | message: {ORANGE}%s", target_name, message);
		}
		else
		{
			PrintToServer(">> You warned %s | message: %s", target_name, message);
		}
	}
	else
	{
		if (client != 0)
		{
			CPrintToChat(client, "{FULLRED}>> You warned {ORANGE}%s{FULLRED} | message: {ORANGE}%s", target_name, message);
		}
		else
		{
			PrintToServer(">> You warned %s | message: %s", target_name, message);
		}
	}
	
	
	
	return Plugin_Handled;
}